/*******************************************************************Copyright Universität Bayreuth 2017*******************************************************************/

idButtonSave.onclick = function () {
	requirejs(["lib/FileSaver.min"], function() {
  	var protocolContent = $('#idProtocol').html().replace(/<br>/g,"\r\n");
		var blob = new Blob([protocolContent], {type: "text/plain;charset=utf-8"});
		var theDate = new Date();
		window.saveAs(blob, "protokoll-"+ getDateTimeString().replace(" ", "_") + ".txt");
	});

}


idButtonComplete.onclick = function ()
{
	/************************************************
	DIN und Objekt ermitteln:
	************************************************/	//Welche DIN und welches Objekt sind per Dropdown ausgewählt:
	selectedDIN = 'DIN 4000-81';
	completeModelOrDataExchangeModel = 'VollstaendigesModell'
	selectedObjectForSTEP = 'Vollbohrer';

	clearProtocol();
	writeProtocol("Date: " + getDateTimeString());
	writeProtocol("File: " + stepFileName);


  /*************************************************************************************************************************************************************************
  **************************************************************************************************************************************************************************
  STEP-Datei checken:
  **************************************************************************************************************************************************************************
  *************************************************************************************************************************************************************************/
 	if(stepFile != "")	//Nur wenn auch Step-File existiert, soll die Funktion ausgeführt werden
	{

		resetInnerHTML("idScrollSTEPWrong");
		changeCSSClass('idScrollSTEPWrong', "scrollSearch");		//Farbe zurücksetzen

    /************************************************
    Variablen anlegen oder initialisieren:
    ************************************************/
    var arGeometricEntityFoundAndCorrect = new Array();    //Speichert die vorhandenen und richtig angelgeten Geometrien, um später die Lage der coordinate systeme und Ebenen etc. zu überprüfen
    var counterForCorrectAxis = 0;  //Counter, um die vorhandenen und richtig angelegten coordinate systeme zu speichern
    var counterForCorrectPlane = 0;
    var counterForCorrectPoint = 0;
		/************************************************
		    							Elements
    ************************************************/
		requSTEP = new Array();
		requSTEP['DIN 4000-81'] = new Array();
		requSTEP['DIN 4000-81']['Vollbohrer'] = new Array();
		requSTEP['DIN 4000-81']['Vollbohrer']['VollstaendigesModell'] = new Array();
		requSTEP['DIN 4000-81']['Vollbohrer']['VollstaendigesModell']['coordinate system'] = new Array();
		requSTEP['DIN 4000-81']['Vollbohrer']['VollstaendigesModell']['point'] = new Array();
		requSTEP['DIN 4000-81']['Vollbohrer']['VollstaendigesModell']['Ebene'] = new Array();

		/* get switch positions */
		var elementsSwitch = new Array();
		elementsSwitch['PCS'] = $('#idPCS').is(':checked');
		elementsSwitch['CIP'] = $('#idCIP').is(':checked');
		elementsSwitch['MCS'] = $('#idMCS').is(':checked');
		elementsSwitch['CSW'] = $('#idCSW').is(':checked');
		elementsSwitch['CRP'] = $('#idCRP').is(':checked');

		if(elementsSwitch['PCS']) {
			requSTEP[selectedDIN][selectedObjectForSTEP][completeModelOrDataExchangeModel]['coordinate system'].push('PCS');
		}
		if(elementsSwitch['CIP']) {
			requSTEP[selectedDIN][selectedObjectForSTEP][completeModelOrDataExchangeModel]['coordinate system'].push('CIP');
		}
		if(elementsSwitch['MCS']) {
			requSTEP[selectedDIN][selectedObjectForSTEP][completeModelOrDataExchangeModel]['coordinate system'].push('MCS');
		}
		if(elementsSwitch['CSW']) {
			requSTEP[selectedDIN][selectedObjectForSTEP][completeModelOrDataExchangeModel]['coordinate system'].push('CSW');
		}
		if(elementsSwitch['CRP']) {
			requSTEP[selectedDIN][selectedObjectForSTEP][completeModelOrDataExchangeModel]['point'].push('CRP');
		}

		var counter = 0;
		var arKeysSTEP = getRequ(requSTEP[selectedDIN][selectedObjectForSTEP][completeModelOrDataExchangeModel]);
		var arSTEPNotFound = new Array();

		writeProtocol("");
		writeProtocol("Items:");

		var anyElement = false;
		for (var key in elementsSwitch) {
			if (elementsSwitch.hasOwnProperty(key))
				anyElement = anyElement || elementsSwitch[key];
		}
		if (!anyElement) writeProtocol("nothing selected");

		/* loop over keys */
		arKeysSTEP.forEach(function(stGeometricEntity){
			arSTEPNotFound[stGeometricEntity] = new Array();
			/* loop over objects for every key */
			requSTEP[selectedDIN][selectedObjectForSTEP][completeModelOrDataExchangeModel][stGeometricEntity].forEach(function(object){
				arGeometricEntityFoundAndCorrect[stGeometricEntity] = new Array();

				var arSTEPFound = allAvailableGroups('=\\s*([^\\(]*)\\(\\s*\\\'('+ object+ ')(?:\\d+\_\\d+)?\'\\s*,[^\\)]*', stepFile);
				//console.log(arSTEPFound);
// return;
				/*Falls Merkmal nicht vorhanden ist:*/
				if(!arSTEPFound.length)
				{
					arSTEPNotFound[stGeometricEntity][counter] = object;
					counter++;
					writeProtocol(object + ' not found.');
				}
				else {
					switch(stGeometricEntity)
					{
						case "coordinate system":
									var counter = 1;
									arSTEPFound.forEach(function(theMatch) {
									var evaluation = "wrong";
										if(theMatch[1] == "AXIS2_PLACEMENT_3D") {
											arGeometricEntityFoundAndCorrect[stGeometricEntity][counterForCorrectAxis] = theMatch[2];   //Speichert die vorhandenen und richtig angelgeten coordinate systeme, um bei diesen später die Orientierung zu überprüfen
											counterForCorrectAxis += 1;
											evaluation = "correct";
										}
										writeProtocol(theMatch[2] + " (" + stGeometricEntity + ") " + counter + " of " + arSTEPFound.length + " " + evaluation + " defined as: " + theMatch[1]);
										counter++;
									});
								break;
						case "point":
									var counter = 1;
									arSTEPFound.forEach(function(theMatch) {
									var evaluation = "wrong";
										if(theMatch[1] == "CARTESIAN_POINT") {
											arGeometricEntityFoundAndCorrect[stGeometricEntity][counterForCorrectAxis] = theMatch[2];   //Speichert die vorhandenen und richtig angelgeten coordinate systeme, um bei diesen später die Orientierung zu überprüfen
											counterForCorrectAxis += 1;
											evaluation = "correct";
										}
										writeProtocol(theMatch[2] + " (" + stGeometricEntity + ") " + counter + " of " + arSTEPFound.length + " " + evaluation + " defined as: " + theMatch[1]);
										counter++;
									});
								break;
						default:
								break;
					}

					// if (arSTEPFound.length == 1) {
					// 	writeProtocol(arSTEPFound[0][2] + " (" + stGeometricEntity + ") " + evaluation + " angelegt als: " + arSTEPFound[0][1]);
					// }	else {
					// 	writeProtocol(arSTEPFound[0][2] + " (" + stGeometricEntity + ") " + arSTEPFound.length + " von " + elementsSwitch[object] + " gefunden");
					// }
				}
			});
		});


		/*Nicht gefundene Elemente ausschreiben:*/
		arKeysSTEP.forEach(function(stGeometricEntity){
			arSTEPNotFound[stGeometricEntity].forEach(function(item){
				writeProtocol(item + " ("+stGeometricEntity+") not found");
			});
		});


		/************************************************
		    							Colors
    ************************************************/
		/* get switch states */
		var colorSwitch = new Array();
		colorSwitch['NOCUT'] = $('#idSwitchNOCUT').is(':checked');
		colorSwitch['CUT'] = $('#idSwitchCUT').is(':checked');
		colorSwitch['CUTTINGEDGELINE'] = $('#idSwitchCUTTINGEDGELINE').is(':checked');
		colorSwitch['NOCUTNOSPIN'] = $('#idSwitchNOCUTNOSPIN').is(':checked');
		colorSwitch['IGNORECUT'] = $('#idSwitchIGNORECUT').is(':checked');
		colorSwitch['IGNORECUTLINE'] = $('#idSwitchIGNORECUTLINE').is(':checked');
		var enteredTolerance = document.getElementById('idChoosenToleranceColourRGB').value;   //Den eingestellten Toleranzwert ermitteln

		writeProtocol("");
		writeProtocol("Colors:");
		// create one single bool from array
		var anyColor = false;
		for (var key in colorSwitch) {
		  if (colorSwitch.hasOwnProperty(key))
		    anyColor = anyColor || colorSwitch[key];
		}
		if (!anyColor) writeProtocol("nothing defined");
		else writeProtocol("tolerance: " + enteredTolerance + " %");

    if(colorSwitch['NOCUT'])
    {
      var toggleNOCUT = checkColourRGB(127,127,127, enteredTolerance);   //COLOUR_RGB überprüfen
      if(toggleNOCUT == 1)  //Nur falls noch nichts gefunden wurde (toggleNOCUT == 1), soll weitergemacht werden
        {toggleNOCUT = checkColorPreDefined(127,127,127, enteredTolerance);}      //DRAUGHTING_PRE_DEFINED_COLOUR überprüfen
      if(toggleNOCUT == 1) { //Hier soll ausgeschrieben werden, wenn ein Wert nicht gefunden wurde
				writeProtocol("NOCUT not foundn");
			} else writeProtocol("NOCUT found");
    }
    if(colorSwitch['CUT'])
    {
      var toggleCUT = checkColourRGB(203.8,203.8,203.8, enteredTolerance); //COLOUR_RGB überprüfen
      if(toggleCUT == 1)  //Nur falls noch nichts gefunden wurde, soll weitergemacht werden
        {toggleCUT = checkColorPreDefined(203.8,203.8,203.8, enteredTolerance);}    //DRAUGHTING_PRE_DEFINED_COLOUR überprüfen
      if(toggleCUT == 1) {
				writeProtocol("CUT not found");
			} else writeProtocol("CUT found");
    }
    if(colorSwitch['CUTTINGEDGELINE'])
    {
      var toggleCUTTINGEDGELINE = checkColourRGB(0,0,255, enteredTolerance); //COLOUR_RGB überprüfen
      if(toggleCUTTINGEDGELINE == 1)  //Nur falls noch nichts gefunden wurde, soll weitergemacht werden
        {toggleCUTTINGEDGELINE = checkColorPreDefined(0,0,255, enteredTolerance);}    //DRAUGHTING_PRE_DEFINED_COLOUR überprüfen
      if(toggleCUTTINGEDGELINE == 1) {
				writeProtocol("CUTTINGEDGELINE/CUTLINE not found");
			} else writeProtocol("CUTTINGEDGELINE/CUTLINE found");
    }
    if(colorSwitch['NOCUTNOSPIN'])
    {
      var toggleNOCUTNOSPIN = checkColourRGB(141,141,141, enteredTolerance); //COLOUR_RGB überprüfen
      if(toggleNOCUTNOSPIN == 1)  //Nur falls noch nichts gefunden wurde, soll weitergemacht werden
        {toggleNOCUTNOSPIN = checkColorPreDefined(141,141,141, enteredTolerance);}    //DRAUGHTING_PRE_DEFINED_COLOUR überprüfen
      if(toggleNOCUTNOSPIN == 1) {
				writeProtocol("NOCUTNOSPIN not found");
			} else writeProtocol("NOCUTNOSPIN found");
    }
    if(colorSwitch['IGNORECUT'])
    {
      var toggleIGNORECUT = checkColourRGB(192,192,192, enteredTolerance); //COLOUR_RGB überprüfen
      if(toggleIGNORECUT == 1)  //Nur falls noch nichts gefunden wurde, soll weitergemacht werden
        {toggleIGNORECUT = checkColorPreDefined(192,192,192, enteredTolerance);}    //DRAUGHTING_PRE_DEFINED_COLOUR überprüfen
      if(toggleIGNORECUT == 1) {
				writeProtocol("IGNORECUT not found");
			} else writeProtocol("IGNORECUT found");
    }
    if(colorSwitch['IGNORECUTLINE'])
    {
      var toggleIGNORECUTLINE = checkColourRGB(0,0,200, enteredTolerance); //COLOUR_RGB überprüfen
      if(toggleIGNORECUTLINE == 1)  //Nur falls noch nichts gefunden wurde, soll weitergemacht werden
        {toggleIGNORECUTLINE = checkColorPreDefined(0,0,200, enteredTolerance);}    //DRAUGHTING_PRE_DEFINED_COLOUR überprüfen
      if(toggleIGNORECUTLINE == 1) {
				writeProtocol("IGNORECUTLINE not found");
			} else writeProtocol("IGNORECUTLINE found");
    }

		return;




























    /************************************************
    Überprüfen, ob die Ursprünge der coordinate system auf der z-Achse des PCS-coordinate systems liegen:
    ************************************************/
    /*Überprüfen, ob das PCS vorhanden ist bzw. angelegt wurde:*/
    var toggleFoundPCS = 0; //Wird gleich 1 gesetzt, falls PCS gefunden wurde
    for(var i=0; i<arGeometricEntityFoundAndCorrect['coordinate system'].length; i++)
    {
      if(arGeometricEntityFoundAndCorrect['coordinate system'][i] == 'PCS')
      {toggleFoundPCS = 1;}
    }

    function checkIfOriginsOnPCS_zAxis()    //Nested Function, um eine Scope-Chain zu erzeugen
    {
      var origins = new Array();
      axis_z = new Array();   //Global. Vektoren werden später noch benötigt


      /*Zunächst die Zeile (zB #823) ermitteln, in der der CARTESIAN_POINT steht (wird in [1] gespeichert) und die Zeile des z-Vektors (wird in [2] gespeichert) ermitteln:*/
      for(var i=0; i<arGeometricEntityFoundAndCorrect['coordinate system'].length; i++) //Es werden nur die coordinate systeme abgefragt, die auch gefunden
      {
        var currentCoSy = arGeometricEntityFoundAndCorrect['coordinate system'][i];   //Das coordinate system, dass im jeweiligen Durchlauf der for-Schleife bearbeitet wird
        var arSTEPFoundPCS_LineNumbers = availableGroup('#\\d*\\s*=\\s*AXIS2_PLACEMENT_3D\\s*\\(\\s*\'\\s*', currentCoSy, '\\s*\'\\s*,\\s*(#[^,]*),\\s*(#[^,]*),\\s*#[^\\)]*\\)\\s*;', stepFile);
        if(arSTEPFoundPCS_LineNumbers)
        {
          origins[currentCoSy] = new Object();
          axis_z[currentCoSy] = new Object();

          //CARTESIAN_POINT ermitteln und speichern:
          var arSTEPFoundPCS_Origin = availableGroup('', arSTEPFoundPCS_LineNumbers[1], '\\s*=\\s*CARTESIAN_POINT\\s*\\(\\s*\'\\s*\'\\s*,\\s*\\(\\s*((-|)\\d*.\\d*(?:E|)(-|)\\d*)\\s*,\\s*((-|)\\d*.\\d*(?:E|)(-|)\\d*)\\s*,\\s*((-|)\\d*.\\d*(?:E|)(-|)\\d*)\\s*\\)\\);', stepFile);

          //Aus Exponentialdarstellung Zahlen machen:
          origins[currentCoSy].x = Number(arSTEPFoundPCS_Origin[1]);
          origins[currentCoSy].y = Number(arSTEPFoundPCS_Origin[4]);  //Durch die Oder-Beziehung (-|) im Regex habe ich eine ungewollte Gruppierung mehr, weshalb z.B. [2] übersprungen wird
          origins[currentCoSy].z = Number(arSTEPFoundPCS_Origin[7]);

          //z-Achse ermitteln:
          var STEPFoundPCS_zAxis = availableGroup('', arSTEPFoundPCS_LineNumbers[2], '\\s*=\\s*DIRECTION\\s*\\(\\s*\'\\s*\'\\s*,\\s*\\(\\s*((-|)\\d*.\\d*(?:E|)(-|)\\d*)\\s*,\\s*((-|)\\d*.\\d*(?:E|)(-|)\\d*)\\s*,\\s*((-|)\\d*.\\d*(?:E|)(-|)\\d*)\\s*\\)\\);', stepFile);

          //Aus Exponentialdarstellung Zahlen machen:
          axis_z[currentCoSy].x = Number(STEPFoundPCS_zAxis[1]);
          axis_z[currentCoSy].y = Number(STEPFoundPCS_zAxis[4]);
          axis_z[currentCoSy].z = Number(STEPFoundPCS_zAxis[7]);
        }
      }

      /*Überprüfen, ob die Ursprünge der KoSys auf der z-Achse des PCS liegen:*/
      for(var i=0; i<arGeometricEntityFoundAndCorrect['coordinate system'].length; i++)
      {
        var currentCoSyWhileOriginCheck = arGeometricEntityFoundAndCorrect['coordinate system'][i];
        if(currentCoSyWhileOriginCheck != 'PCS')
        {
          /*Spezialfälle, wenn eine der Koordinaten der z-Achese des PCS 0 ist:*/
          if(axis_z['PCS'].x == 0)
          {
            if(origins[currentCoSyWhileOriginCheck].x != origins['PCS'].x)
              {
                document.getElementById('idScrollSTEPWrong').innerHTML += "Das coordinate system " +  currentCoSyWhileOriginCheck + " liegt nicht auf der z-Achse des PCS <br>";
                continue;
              }
          }

          if(axis_z['PCS'].y == 0)    //In Gleichung würde man sonst durch Null teilen, was man nicht darf
          {
            if(origins[currentCoSyWhileOriginCheck].y != origins['PCS'].y)
              {
                document.getElementById('idScrollSTEPWrong').innerHTML += "Das coordinate system " +  currentCoSyWhileOriginCheck + " liegt nicht auf der z-Achse des PCS <br>";
                continue;
              }
          }

          if(axis_z['PCS'].z == 0)
          {
            if(origins[currentCoSyWhileOriginCheck].z != origins['PCS'].z)
              {
                document.getElementById('idScrollSTEPWrong').innerHTML += "Das coordinate system " +  currentCoSyWhileOriginCheck + " liegt nicht auf der z-Achse des PCS <br>";
                continue;
              }
          }

          /*Überprüfen, ob point auf Gerade liegt:*/
          if(axis_z['PCS'].x == 0 && axis_z['PCS'].y != 0 && axis_z['PCS'].z != 0)  //x !y !z
          {
            var b = (origins[currentCoSyWhileOriginCheck].y-origins['PCS'].y)/(axis_z['PCS'].y);
            var c = (origins[currentCoSyWhileOriginCheck].z-origins['PCS'].z);
            if(b != c)
              {document.getElementById('idScrollSTEPWrong').innerHTML += "Das coordinate system " +  currentCoSyWhileOriginCheck + " liegt nicht auf der z-Achse des PCS <br>";}
          }
          if(axis_z['PCS'].x != 0 && axis_z['PCS'].y == 0 && axis_z['PCS'].z != 0)  //!x y !z
          {
            var a = (origins[currentCoSyWhileOriginCheck].x-origins['PCS'].x)/(axis_z['PCS'].x);
            var c = (origins[currentCoSyWhileOriginCheck].z-origins['PCS'].z);
            if(a != c)
              {document.getElementById('idScrollSTEPWrong').innerHTML += "Das coordinate system " +  currentCoSyWhileOriginCheck + " liegt nicht auf der z-Achse des PCS <br>";}
          }
          if(axis_z['PCS'].x != 0 && axis_z['PCS'].y != 0 && axis_z['PCS'].z == 0)  //!x !y Z
          {
            var a = (origins[currentCoSyWhileOriginCheck].x-origins['PCS'].x)/(axis_z['PCS'].x);
            var b = (origins[currentCoSyWhileOriginCheck].y-origins['PCS'].y)/(axis_z['PCS'].y);
            if(a != b)
              {document.getElementById('idScrollSTEPWrong').innerHTML += "Das coordinate system " +  currentCoSyWhileOriginCheck + " liegt nicht auf der z-Achse des PCS <br>";}
          }
          if(axis_z['PCS'].x == 0 && axis_z['PCS'].y == 0 && axis_z['PCS'].z != 0)  //x y !z
            {continue;}   //Wenn die Schleife bis hier hin gekommen ist, dann liegt Urspung (x- und y-Koordinate) und Richstung der z-Achse des PCS (x- und y-Koordinate) auf der gleichen Höhe.
          if(axis_z['PCS'].x == 0 && axis_z['PCS'].y != 0 && axis_z['PCS'].z == 0)  //x !y z
            {continue;}   //Analog zu if-Bedingung zuvor
          if(axis_z['PCS'].x != 0 && axis_z['PCS'].y == 0 && axis_z['PCS'].z == 0)  //!x y z
            {continue;}   //Analog zu if-Bedingung zuvor
          if(axis_z['PCS'].x == 0 && axis_z['PCS'].y == 0 && axis_z['PCS'].z == 0)  //x y z
          {
            document.getElementById('idScrollSTEPWrong').innerHTML += "Error: Die z-Achse des PCS ist der Nullvektor";
            continue;
          }
        }
      }
    }
    if(toggleFoundPCS == 1) //Falls das PCS existiert --> Funktion aufrufen
      {checkIfOriginsOnPCS_zAxis();}
    else
      {document.getElementById('idScrollSTEPWrong').innerHTML += "Das coordinate system PCS ist nicht vorhanden, weshalb keine Überprüfung der Orientierung der restlichen coordinate systeme durchgeführt werden kann<br>";}


    /************************************************
    Überprüfen, ob die Ebenen orthogonal zu z-Achse des PCS sind:
    ************************************************/
    function checkIfPlanesAreOrthogonalToPCS_zAxis()
    {
      if(!(axis_z['PCS']))  //Falls die z-Achse des PCS-KoSys nicht existiert, kann auch kein Test auf Orthogonalität erfolgen
      {
        document.getElementById('idScrollSTEPWrong').innerHTML += "Die z-Achse des PCS ist nicht vorhanden, weshalb keine Überprüfung der Orthogonalität der Ebenen durchgeführt werden kann<br>06";
        return;
      }

      var normalVectors = new Array();
      if(!(arGeometricEntityFoundAndCorrect['Ebene']))  //Falls keine Ebenen gefunden werden, die korrekt angelegt wurden
        {return;}

      /*Die Normalenvektoren, der gefundenen und korrekt angelgeten Ebenen speichern:*/
      for(var i=0; i<arGeometricEntityFoundAndCorrect['Ebene'].length; i++)
      {
        var currentPlane = arGeometricEntityFoundAndCorrect['Ebene'][i];   //Die Ebene, die im jeweiligen Durchlauf der for-Schleife bearbeitet wird
        normalVectors[currentPlane] = new Object();

        var arPlane_LineOfAxis = availableGroup('#\\s*\\d+\\s*=\\s*PLANE\\s*\\(\\s*\'\\s*', currentPlane, '\\s*\'\\s*,\\s*(#\\d+)\\s*\\)\\s*;', stepFile);
        var arPlane_LineOfNormalVector = availableGroup('', arPlane_LineOfAxis[1], '=\\s*AXIS2_PLACEMENT_3D\\s*\\(\\s*\'\\s*\'\\s*,\\s*#[^,]*,\\s*(#[^,]*),\\s*#[^\\)]*\\)\\s*;', stepFile);
        var arPlane_NormalVector = availableGroup('', arPlane_LineOfNormalVector[1], '\\s*=\\s*DIRECTION\\s*\\(\\s*\'\\s*\'\\s*,\\s*\\(\\s*((-|)\\d*.\\d*(?:E|)(-|)\\d*)\\s*,\\s*((-|)\\d*.\\d*(?:E|)(-|)\\d*)\\s*,\\s*((-|)\\d*.\\d*(?:E|)(-|)\\d*)\\s*\\)\\);', stepFile);

        //Aus Exponentialdarstellung Zahlen machen:
        normalVectors[currentPlane].x = Number(arPlane_NormalVector[1]);
        normalVectors[currentPlane].y = Number(arPlane_NormalVector[4]);  //Durch die Oder-Beziehung (-|) im Regex habe ich eine ungewollte Gruppierung mehr, weshalb z.B. [2] übersprungen wird
        normalVectors[currentPlane].z = Number(arPlane_NormalVector[7]);
      }

      /*Berechnen, ob jeweilige Ebene orthogonal zu z-Achse des PCS ist:*/
      for(var i=0; i<arGeometricEntityFoundAndCorrect['Ebene'].length; i++)
      {
        var currentPlaneWhileOrthogonalCheck = arGeometricEntityFoundAndCorrect['Ebene'][i];   //Die Ebene, die im jeweiligen Durchlauf der for-Schleife bearbeitet wird
        /*Winkel zwischen den beiden Vektoren berechnen aus der Formen cos(alpha)=(a*b)/(|a|*|b|):*/
				angleBetweenVectorsDegreesRounded = calculateAngle(normalVectors[currentPlaneWhileOrthogonalCheck].x, normalVectors[currentPlaneWhileOrthogonalCheck].y, normalVectors[currentPlaneWhileOrthogonalCheck].z, axis_z['PCS'].x, axis_z['PCS'].y, axis_z['PCS'].z);

        if(!(angleBetweenVectorsDegreesRounded == 180 || angleBetweenVectorsDegreesRounded == 0))
          {document.getElementById('idScrollSTEPWrong').innerHTML += "Die Ebenen " +  currentPlaneWhileOrthogonalCheck + " ist nicht orthogonal zur z-Achse des PCS <br>";}
      }
    }
    if(toggleFoundPCS == 1) //Falls das PCS existiert --> Funktion aufrufen
      {checkIfPlanesAreOrthogonalToPCS_zAxis();}
    else
      {document.getElementById('idScrollSTEPWrong').innerHTML += "Das coordinate system PCS ist nicht vorhanden, weshalb keine Überprüfung der Orientierung der Ebenen durchgeführt werden kann<br>";}



    /************************************************
    MANIFOLD_SOLID_BREP überprüfen:
    ************************************************/
    function checkMANIFOLD_SOLID_BREP()
    {
      const rxMANIFOLD_SOLID_BREP = /#\s*\d*\s*=\s*MANIFOLD_SOLID_BREP\s*\(\s*'[^']*'\s*,\s*#\d*\s*\)\s*;/g;  //Allgemein erst mal Zeilen heraussuchen
      var arMANIFOLD_SOLID_BREP = stepFile.match(rxMANIFOLD_SOLID_BREP);

      if(!arMANIFOLD_SOLID_BREP)    //Falls nichts gefunden wurde, soll aus der Funktion gesprungen werden
        {return;}

      for(i=0 ; i<arMANIFOLD_SOLID_BREP.length; i++)
      {
        const rxMANIFOLD_SOLID_BREPLine = /(#\d*)\s*=\s*MANIFOLD_SOLID_BREP\s*\(\s*'[^']*'\s*,\s*#\d*\s*\)\s*;/;   //Nach der Nummer gruppieren, in der die Farbe stehen müsste
        var arMANIFOLD_SOLID_BREPLine = arMANIFOLD_SOLID_BREP[i].match(rxMANIFOLD_SOLID_BREPLine);

        if(!arMANIFOLD_SOLID_BREPLine[1]) //Falls keine Zeile gefunden wurde, soll direkt mit dem nächsten MANIFOLD_SOLID_BREP weitergemacht werden
        {
          document.getElementById('idScrollSTEPWrong').innerHTML += "'" + arMANIFOLD_SOLID_BREP[i] + "' enthält keine Zeile<br>";
          continue;
        }

        rxSTYLED_ITEM = regexConnect("#\\d*\\s*=\\s*STYLED_ITEM\\s*\\('[^']*'\\s*,\\s*\\(\\s*(#\\d*)\\s*\\)\\s*,\\s*", arMANIFOLD_SOLID_BREPLine[1], "\\s*\\)\\s*;")
        var arCURVE_STYLEColorFound = stepFile.match(rxSTYLED_ITEM);
        if(!arCURVE_STYLEColorFound) //Falls keine Zeile gefunden wurde, soll direkt mit dem nächsten MANIFOLD_SOLID_BREP weitergemacht werden
        {
          document.getElementById('idScrollSTEPWrong').innerHTML += "'" + arMANIFOLD_SOLID_BREP[i] + "' ist mit keinem STYLED_ITEM verknüpft<br>";
          continue;
        }
        //Zeilen nacheinander durchgehen, bis zu keiner neuen Zeile verknüpft ist:
        var rxFollower = regexConnect(arCURVE_STYLEColorFound[1], "\\s*=\\s*([^(]*)[^#]*(#\\d*)[^)]*\\)*\\s*;", "");    //Die nächste Zeilennummer finden
        var arFollower = stepFile.match(rxFollower);

        if(!arFollower)
        {
          document.getElementById('idScrollSTEPWrong').innerHTML += "'" + arMANIFOLD_SOLID_BREP[i] + "': Suchausdruck hat kein Nachfolgeelement gefunden<br>";
          continue;
        }

        while(arFollower)
        {
          var followLine = arFollower[2]; //Aktuelle Zeile speichern... Durch die Bedingung if(!arFollower) wird auf jeden Fall eine Zeile gefunden, denn sonst würde Schleife bereits oben mit continue unterbrochen werden
          rxFollower = regexConnect(arFollower[2], "\\s*=\\s*([^(]*)[^#]*(#\\d*)[^)]*\\)*\\s*;", "");    //Die nächste Zeilennummer finden
          arFollower = stepFile.match(rxFollower);
        }

        //Überprüfen, ob die letzte verknüpfte Zeile ein COLOR_RGB enthält:
        var rxColourOfMANIFOLD_SOLID_BREP = regexConnect(followLine, "\\s*=\\s*([^(]*)", "");  //Wird es was finden, sonst würde if(!arFollower) die Schleife bereits abgebrochen haben, bzw. var followLine = arFollower[2]; nur eine bereits gefundene Zeile enthalten
        var arColourOfMANIFOLD_SOLID_BREP = stepFile.match(rxColourOfMANIFOLD_SOLID_BREP);
        if(!arColourOfMANIFOLD_SOLID_BREP)
        {
          document.getElementById('idScrollSTEPWrong').innerHTML += "'" + arMANIFOLD_SOLID_BREP[i] + "': Letztes verknüpftes Element ist kein COLOUR_RGB oder nicht vorhanden<br>"; //Wenn es ein COLOUR_RGB wäre, würde Suchausdruck etwas finden oder Element ist nicht angelegt
          continue;
        }
        if(arColourOfMANIFOLD_SOLID_BREP[1] == "COLOUR_RGB" || arColourOfMANIFOLD_SOLID_BREP[1] == "DRAUGHTING_PRE_DEFINED_COLOUR") //Falls COLOUR_RGB gefunden wurde, ist alles korrekt und es kann mit der nächsten MANIFOLD-Zeile weitergemacht werden
          {continue;}
        else
        {
          document.getElementById('idScrollSTEPWrong').innerHTML += "'" + arMANIFOLD_SOLID_BREP[i] + "' endet in keiner Farbzuweisung, sondern mit '" + arColourOfMANIFOLD_SOLID_BREP[1] + "'<br>";
          continue;
        }
      }
    }
    checkMANIFOLD_SOLID_BREP();



    /************************************************
    Überprüfen, ob CURVE_STYLE-Elemente eine Farbe zugewiesen wurde:
    ************************************************/
    var arCURVE_STYLEColorNotFound = checkCURVE_STYLE();
    for(var i = 0; i<arCURVE_STYLEColorNotFound.length; i++) //Im Browser ausschreiben
    {
      document.getElementById('idScrollSTEPWrong').innerHTML += 'Die Zeile \'' + arCURVE_STYLEColorNotFound[i] + '\' enthält keine Farbe<br>';
    }


    /************************************************
    Rahmenfarben der Scroll-Boxen ändern:
    ************************************************/
    /*Nicht gefundene vordefinierte Farben:*/
    if(document.getElementById('idColourRGB').innerHTML == "")
      {changeCSSClass('idColourRGB', "scrollSearch success2");}
    else
      {changeCSSClass('idColourRGB', "scrollSearch danger2");}

    /*Vorhandene, aber falsch angelegte Geometrien:*/
    if(document.getElementById('idScrollSTEPWrong').innerHTML == "")
      {changeCSSClass('idScrollSTEPWrong', "scrollSearch success2");}
    else
      {changeCSSClass('idScrollSTEPWrong', "scrollSearch danger2");}

    /*Nicht gefundene Geometrien:*/
    var STEPColourCheck1 = document.getElementById("idNotFoundKosy").innerHTML;
		var STEPColourCheck2 = document.getElementById("idNotFoundEbene").innerHTML;
		var STEPColourCheck3 = document.getElementById("idNotFoundAchse").innerHTML;
		var STEPColourCheck4 = document.getElementById("idNotFoundpoint").innerHTML;
		// if(STEPColourCheck1=="" && STEPColourCheck2=="" && STEPColourCheck3=="" && STEPColourCheck4=="")
		// 	{changeCSSClass('idScrollSTEPNotFound', "scrollSearch success2");}
		// else
		// 	{changeCSSClass('idScrollSTEPNotFound', "scrollSearch danger2");}
  }
}


/********************************************************************************
STEP-Datei: Überprüfen, ob CURVE_STYLE-Elemente eine Farbe zugewiesen wurde:
********************************************************************************/
function checkCURVE_STYLE()
{
  var arCURVE_STYLEColorNotFound = new Array();
  var counterCURVE_STYLE = 0;

  const rxCURVE_STYLE = /#\d*=\s*CURVE_STYLE\s*\(\s*'[^']*',\s*#\d*\s*,\s*POSITIVE_LENGTH_MEASURE\s*\([^\)]*\),\s*#\d*\s*\)\s*;/g;  //Allgemein erst mal Zeilen heraussuchen
  var arCURVE_STYLE = stepFile.match(rxCURVE_STYLE);
  if(arCURVE_STYLE)
  {
    for(i=0 ; i<arCURVE_STYLE.length; i++)
    {
      //Zeile finden:
      const rxCURVE_STYLELine = /#\d*=\s*CURVE_STYLE\s*\(\s*'[^']*',\s*#\d*\s*,\s*POSITIVE_LENGTH_MEASURE\s*\([^\)]*\),\s*(#\d*)\s*\)\s*;/;   //Nach der Nummer gruppieren, in der die Farbe stehen müsste
      var arCURVE_STYLELine = arCURVE_STYLE[i].match(rxCURVE_STYLELine);
      //Überprüfen, ob Zeile 'COLOR_RGB' oder 'DRAUGHTING_PRE_DEFINED_COLOUR' enthält:
      if(arCURVE_STYLELine)
      {
        var rxCURVE_STYLEColor = regexConnect(arCURVE_STYLELine[1], '\\s*=\\s*([^(]*)', "");
        var arCURVE_STYLEColorFound = stepFile.match(rxCURVE_STYLEColor);
      }

      if((arCURVE_STYLEColorFound && (arCURVE_STYLEColorFound[1] != 'COLOUR_RGB' && arCURVE_STYLEColorFound[1] != 'DRAUGHTING_PRE_DEFINED_COLOUR')) || !arCURVE_STYLEColorFound)
      {
        arCURVE_STYLEColorNotFound[counterCURVE_STYLE] = arCURVE_STYLE[i];
        counterCURVE_STYLE++;
      }

    }
  }
  return(arCURVE_STYLEColorNotFound);
}


/********************************************************************************
STEP-Datei: DRAUGHTING_PRE_DEFINED_COLOUR überprüfen:
********************************************************************************/
function checkColorPreDefined (EnteredValueRGBR, EnteredValueRGBG, EnteredValueRGBB, enteredTolerance)
{
  const rxRGBColorPreDefined = /#\d*\s*=\s*DRAUGHTING_PRE_DEFINED_COLOUR\s*\(\s*'\s*\w*\s*'\s*\)\s*;/g;
  var arRGBResultGeneralColorPreDefined = stepFile.match(rxRGBColorPreDefined);   //zunächst alle Zeilen in arRGBResultGeneralColorPreDefined speichern
  if(arRGBResultGeneralColorPreDefined)
  {
    for(i=0; i<arRGBResultGeneralColorPreDefined.length; i++)
    {
      const rxRGBGroupColorPreDefined = /#\d*\s*=\s*DRAUGHTING_PRE_DEFINED_COLOUR\s*\(\s*'\s*(\w*)\s*'\s*\)\s*;/;		//Einen gefundenen String nach dem anderen durchgehen und nach R-, G-, B- Wert gruppieren
      var arRGBGroupResultColorPreDefined = arRGBResultGeneralColorPreDefined[i].match(rxRGBGroupColorPreDefined);

      switch(arRGBGroupResultColorPreDefined[1])
      {
        case 'red':
          var togglePreDefined = readRGBColorPreDefined(1, 0, 0, EnteredValueRGBR, EnteredValueRGBG, EnteredValueRGBB, enteredTolerance);
          if(togglePreDefined == 0)   //hier will ich ja nur wissen, ob die Farbe gefunden wurde, d.h. wenn die Funktion readreadRGBColorPreDefined den Wert 0 zurückgibt, heißt das, dass sie einen Wert gefunden hat, der im Toleranzbereich liegt und die Funktion kann mit dem Rückgabewert 0 beendet werden
            {return(togglePreDefined);}
          break;
        case 'green':
          var togglePreDefined = readRGBColorPreDefined(0, 1, 0, EnteredValueRGBR, EnteredValueRGBG, EnteredValueRGBB, enteredTolerance);
          if(togglePreDefined == 0)
            {return(togglePreDefined);}
          break;
        case 'blue':
          var togglePreDefined = readRGBColorPreDefined(0, 0, 1, EnteredValueRGBR, EnteredValueRGBG, EnteredValueRGBB, enteredTolerance);
          if(togglePreDefined == 0)
            {return(togglePreDefined);}
          break;
        case 'yellow':
          var togglePreDefined = readRGBColorPreDefined(1, 1, 0, EnteredValueRGBR, EnteredValueRGBG, EnteredValueRGBB, enteredTolerance);
          if(togglePreDefined == 0)
            {return(togglePreDefined);}
          break;
        case 'magenta':
          var togglePreDefined = readRGBColorPreDefined(1, 0, 1, EnteredValueRGBR, EnteredValueRGBG, EnteredValueRGBB, enteredTolerance);
          if(togglePreDefined == 0)
            {return(togglePreDefined);}
          break;
        case 'cyan':
          var togglePreDefined = readRGBColorPreDefined(0, 1, 1, EnteredValueRGBR, EnteredValueRGBG, EnteredValueRGBB, enteredTolerance);
          if(togglePreDefined == 0)
            {return(togglePreDefined);}
          break;
        case 'black':
          var togglePreDefined = readRGBColorPreDefined(0, 0, 0, EnteredValueRGBR, EnteredValueRGBG, EnteredValueRGBB, enteredTolerance);
          if(togglePreDefined == 0)
            {return(togglePreDefined);}
          break;
        case 'white':
          var togglePreDefined = readRGBColorPreDefined(1, 1, 1, EnteredValueRGBR, EnteredValueRGBG, EnteredValueRGBB, enteredTolerance);
          if(togglePreDefined == 0)
            {return(togglePreDefined);}
          break;
      }
    }
  }
  return(1); //Falls kein togglePreDefined gefunden wurde
}


/********************************************************************************
STEP-Datei: COLOUR_RGB überprüfen:
********************************************************************************/
function checkColourRGB (selectedPredefinedR, selectedPredefinedG, selectedPredefinedB, enteredTolerance)
{
  const rxColourRGBGeneral = /#\d*=COLOUR_RGB\s*\(\s*'[^']*'\s*,\s*[^,]*,[^,]*,[^)]*\);/g;
  var arColourRGBResultGeneral = stepFile.match(rxColourRGBGeneral);   //zunächst alle COLOUR_RGB finden und zeilenweise in Array speichern
  if(arColourRGBResultGeneral)
  {
    for(i=0; i<arColourRGBResultGeneral.length; i++)
    {
    	const rxColourRGBGroup = /COLOUR_RGB\s*\(\s*'[^']*'\s*,\s*([^,]*),([^,]*),([^)]*)\);/;
    	var arColourRGBResult = arColourRGBResultGeneral[i].match(rxColourRGBGroup);
    	var FoundColorRDecimal = Number(arColourRGBResult[1]);		//Macht aus Exponentialdarstellung eine Dezimalzahl; bzw. falls Wert bereits in Dezimaldarstellung angegeben wurde, bleibt es eine Dezimaldarstellung
    	var FoundColorGDecimal = Number(arColourRGBResult[2]);		//Macht aus Exponentialdarstellung eine Dezimalzahl; bzw. falls Wert bereits in Dezimaldarstellung angegeben wurde, bleibt es eine Dezimaldarstellung
    	var FoundColorBDecimal = Number(arColourRGBResult[3]);		//Macht aus Exponentialdarstellung eine Dezimalzahl; bzw. falls Wert bereits in Dezimaldarstellung angegeben wurde, bleibt es eine Dezimaldarstellung
    	var selectedPredefinedRPercent = selectedPredefinedR/255;				//Eingegebenen Wert in 0 bis 1 Skala umwandeln... Falls nichts eingegeben wurde, wird EnteredValueRGBRPercent zu 0
    	var selectedPredefinedGPercent = selectedPredefinedG/255;				//Eingegebenen Wert in 0 bis 1 Skala umwandeln... Falls nichts eingegeben wurde, wird EnteredValueRGBGPercent zu 0
    	var selectedPredefinedBPercent = selectedPredefinedB/255;				//Eingegebenen Wert in 0 bis 1 Skala umwandeln... Falls nichts eingegeben wurde, wird EnteredValueRGBBPercent zu 0

      var toggleColourRGBNotWithinTolerance = 0;	   //Zunächst mit 0 initialisieren
    	toggleColourRGBNotWithinTolerance = checkToleranceRange(selectedPredefinedRPercent, FoundColorRDecimal, 'idChoosenToleranceColourRGB', enteredTolerance);
      if(toggleColourRGBNotWithinTolerance == 0)     //Nur wenn der Wert zuvor im Toleranzbereich (toggleColourRGBNotWithinTolerance == 0) liegt
    	 {toggleColourRGBNotWithinTolerance = checkToleranceRange(selectedPredefinedGPercent, FoundColorGDecimal, 'idChoosenToleranceColourRGB', enteredTolerance);}
      if(toggleColourRGBNotWithinTolerance == 0)     //Nur wenn der Wert zuvor im Toleranzbereich (toggleColourRGBNotWithinTolerance == 0) liegt
    	 {toggleColourRGBNotWithinTolerance = checkToleranceRange(selectedPredefinedBPercent, FoundColorBDecimal, 'idChoosenToleranceColourRGB', enteredTolerance);}
      if(toggleColourRGBNotWithinTolerance == 0)     //Nur wenn der Wert zuvor im Toleranzbereich (toggleColourRGBNotWithinTolerance == 0) liegt
        {return(toggleColourRGBNotWithinTolerance);} //Falls der Wert 0 ist, bedeutet das, dass ein Wert gefunden wurde, der im Toleranzbereich liegt. D.h. die Funktion kann beendet werden (mit Rückgabewert 1)
    }
    /*Jetzt noch abchecken, ob eine vordefinierte Farbe (wie z.B. 'green' im Toleranzbereich liegt):*/
    return toggleColourRGBNotWithinTolerance;         //Falls der Wert nicht im Toleranzbereich liegt, ist toggleColourRGBNotWithinTolerance=1, was hier auch als Rückgabewert übergeben wird
  }
  else
   {return 1;}    //1 bedeutet, dass kein Wert gefunden wurde, der im Toleranzbereich liegt
}


/********************************************************************************
XML-Datei: Nicht vorhandene Merkmale und Merkmale ohne Wert mittels MOC überprüfen:
********************************************************************************/
function checkMOC (idSelectedMOCCheckbox, selectedMOC, idWriteInNotAvailabel, idWriteInAvailabelWithoutValue)
{
  if($(idSelectedMOCCheckbox).is(':checked'))
    {
      /**Vorhandene Merkmale:**/
      //Suchen:
      var availableMOC = availableCharacteristics('<PropertyName source="din_mk"> *(', requXML[selectedDIN][selectedObject][selectedMOC], ') *<\/PropertyName>', XMLFile);

      /**Nicht vorhandene Ausdrücke:**/
      //Suchen:
      var notAvailableMOC = notAvailableCharacteristics('<PropertyName source="din_mk"> *(', requXML[selectedDIN][selectedObject][selectedMOC], ') *<\/PropertyName>', XMLFile);
      //Ausschreiben:
      if(notAvailableMOC.length > 0)
        {writeBrowser(notAvailableMOC, idWriteInNotAvailabel, selectedMOC, "add");}

      /**Vorhandene Ausdrücke, die keinen Value haben:**/
      //Suche:
      var arFoundNoValue = notAvailableCharacteristics('<PropertyName source="din_mk">', availableMOC, '<\/PropertyName> *<Value>(.{1,50})<\/Value>', flatXMLFile);
      //Ausschreiben:
      writeBrowser(arFoundNoValue, idWriteInAvailabelWithoutValue, selectedMOC, "add");
    }
}


/********************************************************************************
XML-Datei: Gibt Array zurück, der die gefundenen Merkmale/Characteristics enthält:
********************************************************************************/
function availableCharacteristics (stRegex1, arCharacteristics, stRegex2, fileName)
{
	var inCounUp = 0;
	var arMatches = [];
	var arSearchTerm = ['','',''];
	arSearchTerm[0] = stRegex1;
	arSearchTerm[2] = stRegex2;


	for(var i=0; i<arCharacteristics.length; i++)
		{
			arSearchTerm[1] = arCharacteristics[i];
			var stSearchTerm = arSearchTerm.join("");
			var rxSearchTerm = new RegExp(stSearchTerm,"g");    		//Aus String einen Regex machen
			var arSingleMatch = rxSearchTerm.exec(fileName);
			if (arSingleMatch !== null)
			{
				arMatches[inCounUp] = arCharacteristics[i];
				inCounUp++;
			}
		}
	return(arMatches);
}


/********************************************************************************
XML-Datei: Gibt Array zurück, der die Gruppen enthält, mit dem die Arrays gruppiert wurden:
********************************************************************************/
function availableGroup (stRegex1, stCharacteristic, stRegex2, fileName)
{
  // console.log(fileName);
	var inCounUp = 0;
	var arMatches = [];
	var arSearchTerm = ['','',''];
	arSearchTerm[0] = stRegex1;
	arSearchTerm[2] = stRegex2;

	arSearchTerm[1] = stCharacteristic;
	var stSearchTerm = arSearchTerm.join("");

	var rxSearchTerm = new RegExp(stSearchTerm,"g");    		//Aus String einen Regex machen
	var arMatches = fileName.match(stSearchTerm);
	return(arMatches);
}

function allAvailableGroups (stSearchTerm, fileName)
{
	var arMatches = [];
	var fileCopy = fileName;

	var rxSearchTerm = new RegExp(stSearchTerm,"g");    		//Aus String einen Regex machen

	// var aMatch = fileCopy.match(stSearchTerm);
	// arMatches.push(aMatch);

	/* first look for string */
	var matchPos = fileCopy.search(stSearchTerm);
	/* while string is found repeat */
	while (matchPos != -1) {
		/* find match (which hast to extist) and add to array */
		aMatch = fileCopy.match(stSearchTerm)
		arMatches.push(aMatch);
		/* cut haystack and look for next string */
		fileCopy = fileCopy.substring(matchPos+1);
		matchPos = fileCopy.search(stSearchTerm);
	}
	return(arMatches);
}


/********************************************************************************
XML-Datei: Gibt Array zurück, der die NICHT gefundenen Merkmale/Characteristics enthält:
********************************************************************************/
function notAvailableCharacteristics (stRegex1, arCharacteristics, stRegex2, fileName)
{
	var inCounUp = 0;
	var arNoMatches = [];
	var arSearchTerm = ['','',''];
	arSearchTerm[0] = stRegex1;
	arSearchTerm[2] = stRegex2;

	for(var i=0; i<arCharacteristics.length; i++)
	{
		arSearchTerm[1] = arCharacteristics[i];
		var stSearchTerm = arSearchTerm.join("");

		var rxSearchTerm = new RegExp(stSearchTerm,"g");    			//Aus String einen Regex machen
		var arSingleMatch = rxSearchTerm.exec(fileName);

		if (arSingleMatch == null)
		{
			arNoMatches[inCounUp] = arCharacteristics[i];
			inCounUp++;
		}
	}
	return(arNoMatches);
}
