/*******************************************************************Copyright Universität Bayreuth 2017*******************************************************************/
stepFile = "";    //Zunächst leere Datei anlegen
XMLFile = "";     //Zunächst leere Datei anlegen

function processStepXMLFile(fileName,fileEnding,file)
{
  var reader = new FileReader();
  reader.onload = function(progressEvent)
	{
    stepFileName = fileName;
    /********************************************************************************
    *********************************************************************************
    STEP-Dateien:
    *********************************************************************************
    ********************************************************************************/
		if (fileEnding.toUpperCase()=="STP" || fileEnding.toUpperCase()=="STEP")
		{
      /********************************************************************************
      Inhalte zurücksetzten und Datei speichern:
      ********************************************************************************/
      //Zunächst alles löschen
      $("#idButtonDeleteStep").click();

      //Zunächst den Delete-Button wieder einblenden:
      document.getElementById("idButtonDeleteStep").className = "btn btn-default btn-xs deleteButton";

      //Eingelesene Dateien auf Variablen speichern:
			stepFile = this.result;
      searchFile = stepFile;
      flatStepFile = flattenFile(stepFile);  	//Zunächst muss die stepFile geglättet werden, weil reguläre Ausdrücke normalerweise nicht über eine Zeile hinausgehen

      //Such-Panelbox aktiviern, sobald Datei eingelesen wird:
      $("#idDropdownSearch").change();   //ein onchang() simulieren
      readRGB();      //Die RGB-Sroll-Panelbox aktualisieren


      /********************************************************************************
      Datei-Name, Ersteller-Name, Datum, Software ausschreiben:
      ********************************************************************************/
      //Datei-Name im Browser anzeigen lassen:
      document.getElementById("idDateiNameSTEP").innerHTML = fileName;

      //Name des Erstellers, Datum und Software auslesen:
			const rxInfo = /FILE_NAME\s*\([^']*'[^']*'\s*,[^']*'([^']*)'\s*,[^']*\(\s*'([^']*)'\s*\)\s*,[^']*\(\s*'[^']*'\s*\)\s*,[^']*'[^']*'\s*,[^']*'([^']*)'\s*,[^']*'[^']*'\s*\)\s*;\s*FILE_SCHEMA/;
      var arInfo = flatStepFile.match(rxInfo);

      //Name des Erstellers:
      if (arInfo[2])
        {document.getElementById("idName").innerHTML = arInfo[2];}
      else
        {document.getElementById("idName").innerHTML = "";}

      //Datum:
			if (arInfo[1])
			  {document.getElementById("idDate").innerHTML = arInfo[1];}
			else
				{document.getElementById("idDate").innerHTML = "";}

			//Software:
			if (arInfo[3])
				{document.getElementById("idSoftware").innerHTML = arInfo[3];}
			else
				{document.getElementById("idSoftware").innerHTML = "";}

      /* find AP */
      const rxInfo2 = /FILE_SCHEMA\s*\(\s*\(\s*'\s*\S+\s*\{\s*\d\s*\d\s*10303\s*(\d{3})/;

			if (flatStepFile.search(rxInfo2) != -1){
        var arInfo2 = flatStepFile.match(rxInfo2);
				document.getElementById("idApplicationProtocol").innerHTML = arInfo2[1];}
			else
				{document.getElementById("idApplicationProtocol").innerHTML = "";}

      clearProtocol();
		}


    /********************************************************************************
    *********************************************************************************
    XML-Dateien:
    *********************************************************************************
    ********************************************************************************/
		if (fileEnding=="xml")
    {
      /********************************************************************************
      Inhalte zurücksetzten und Datei speichern:
      ********************************************************************************/
      //Zunächst alles löschen:
      $("#idButtonDeleteXML").click();

      //Zunächst den Delete-Button wieder einblenden:
      document.getElementById("idButtonDeleteXML").className = "btn btn-default btn-xs deleteButton";

      //Eingelesene Datei auf Variable speicher:
			XMLFile = this.result;
      flatXMLFile = flattenFile(XMLFile);  	//Zunächst muss die stepFile geglättet werden, weil reguläre Ausdrücke normalerweise nicht über eine Zeile hinausgehen

      //Such-Panelbox aktiviern, sobald Datei eingelesen wird:
      $("#idDropdownSearch").change();   //ein onchang() simulieren
      readRGB();      //Die RGB-Sroll-Panelbox aktualisieren


      /********************************************************************************
      Datei-Name im Browser ausschreiben:
      ********************************************************************************/
      //Datei-Name im Browser anzeigen lassen:
      document.getElementById("idDateiNameXML").innerHTML = fileName;


      /********************************************************************************
      DIN und Objekt automatisch auslesen:
      ********************************************************************************/
      //DIN automatisch auslesen:
      const rxAutoDIN = /<\s*PropertyName\s*source\s*=\s*"[^"]*"\s*>\s*NSM\s*<\s*\/\s*PropertyName\s*>\s*<\s*Value\s*>([^<]*)<\s*\/\s*Value\s*>/;
      var arFoundDIN = flatXMLFile.match(rxAutoDIN);
      arFoundDIN[1] = arFoundDIN[1].replace("DIN","DIN "); //Es muss ein Leerzeichen nach DIN eingefügt werden, damit konform mit den angelegten arrays in requirements.js
      document.getElementById('foundDIN').innerHTML = arFoundDIN[1];
      var arDIN = getRequ(requXML);
      var DINexists = 0;          //Kontroll-Variable, die gesetzt wird, falls eine DIN vorhanden ist (mit ihr ändert man dann die Border-Color)
      for(j = 0; j < arDIN.length; j++)
      {
        if (arDIN[j] == arFoundDIN[1])     //Die DIN soll nur als DropDown-Option gewählt werden, wenn sie auch tatsächlich existiert
        {
          changeDropdownOption('idCompleteDIN', arDIN[j]);
          DINexists = 1;
          $('#idCompleteDIN').change();   //Die Objekte müssen der DIN entsprechen
        }
      }
      if (DINexists == 1)
        {document.getElementById('foundDIN').style.border = "1px solid #75c658";}   //falls die DIN als Option im Drop-Down auch existiert, wird der Rahmen grün
      else
        {document.getElementById('foundDIN').style.border = "1px solid #cb4f4f";}   //falls eine DIN in der XML-Datei gefunden wird, aber als Option im Drop-Down Menü nicht existeiert, wird die DIN zwar in den Div geschrieben, aber der Rahmen wird rot... Die DIN im Drop-Down bleibt
      if (arFoundDIN[1] == "")
        {document.getElementById('foundDIN').style.border = "1px solid #bdbdbd";}   //falls in der XML-Datei keine DIN gefunden wird, dann soll der Rahmen wieder grau werden

      //Objekt automatisch auslesen:
      const rxAutoObject = /<\s*\/\s*Level\s*>\s*<PropertyName\s+source\s*=\s*"[^"]*"\s*>\s*BLD\s*<\s*\/\s*PropertyName\s*>\s*<\s*Value\s*>([^<]*)<\s*\/\s*Value\s*>/;
      var arFoundObject = flatXMLFile.match(rxAutoObject);
      document.getElementById('foundObjectRaw').innerHTML = arFoundObject[1];
      var arObjects = getRequ(requXML[arFoundDIN[1]]);       //Die angelegten Objekte der gefundenen DIN ermitteln und speichern
      arFoundObject[1] = arObjects[arFoundObject[1]-1];      //in der XML-Datei wird z.B. "1" gefunden... "1" steht für Vollbohrer, weshalb hier die "1" zu einem Vollbohrer überschrieben wird
      document.getElementById('foundObject').innerHTML = arFoundObject[1];
      var ObjectExists = 0;                                  //Kontroll-Variable, die gesetzt wird, falls eine Objekt vorhanden ist (mit ihr ändert man dann die Border-Color)
      for(i = 0; i < arObjects.length; i++)
      {
        if (arObjects[i] == arFoundObject[1])                //Das Objekt soll nur als DropDown-Option gewählt werden, wenn es auch tatsächlich existiert
        {
          changeDropdownOption('idCompleteObject', arObjects[i]);
          ObjectExists = 1;
        }
      }
      if (ObjectExists == 1)
        {document.getElementById('foundObject').style.border = "1px solid #75c658";}    //falls das Objekt als Option im Drop-Down auch existiert, wird der Rahmen rot
      else
        {document.getElementById('foundObject').style.border = "1px solid #cb4f4f";}    //falls das Objekt in der XML-Datei gefunden wird, aber als Option im Drop-Down Menü nicht existeiert, wird das Objekt zwar in den Div geschrieben, aber der Rahmen wird rot... Das Objekt im Drop-Down bleibt

      if (arFoundObject[1] == "")
        {document.getElementById('foundObject').style.border = "1px solid #bdbdbd";}    //falls nichts gefunden wurde, oder das Objekt nicht existiert, wird die Farbe wieder zurückgesetzt
		}
  }
  reader.readAsText(file);
}
