/*******************************************************************Copyright Universität Bayreuth 2017*******************************************************************/

/********************************************************************************
Bei Programmstart vordefinierte Farbe einstellen:
********************************************************************************/
document.getElementById("idColorPicker").value = "#bdbdbd";   //Farbe zunächst auf grau setzen, damit Colorpicking-Area auch reagiert, sonst wäre schwarz eingestellt, was einen RBG-Wert von 0 0 0 entspricht
document.getElementById('idRGBR').value = 189; 		//Bei neu laden der Seite, müssen auch die RGB-Felder wieder auf das #bdbdbd zurückgestellt werden
document.getElementById('idRGBG').value = 189;		//Bei neu laden der Seite, müssen auch die RGB-Felder wieder auf das #bdbdbd zurückgestellt werden
document.getElementById('idRGBB').value = 189;		//Bei neu laden der Seite, müssen auch die RGB-Felder wieder auf das #bdbdbd zurückgestellt werden


/********************************************************************************
RGB-Werte anpassen, wenn man beim Color-Picker eine Farbe einstellt und Suchfuntkion starten, wenn man Ok drückt:
********************************************************************************/
$('#idColorPicker').on('input', function() {
	var choosenColor = document.getElementById('idColorPicker').value;
	var choosenR = hexToRgb(choosenColor).r;
	var choosenG = hexToRgb(choosenColor).g;
	var choosenB = hexToRgb(choosenColor).b;
	document.getElementById('idRGBR').value = choosenR;
	document.getElementById('idRGBG').value = choosenG;
	document.getElementById('idRGBB').value = choosenB;
} )

//Falls man Color-Picker öffnet, Farbe ändert und Ok drückt soll die Scroll-Box geändert werden:
idColorPicker.onchange = function ()
	{readRGB();}


/********************************************************************************
Farben auslesen, wenn man ein RGB-Wert ändert:
********************************************************************************/
//Falls man R-Wert des Input-Feldes ändert:
$("#idRGBR").bind('keyup mouseup', function () {
	changeColorPickerValue();		//wenn im Input-Feld der Wert geändert wird, dann soll der Wert des Color-Pickers ebenfalls geändert werden
	readRGB();		//Scroll-Ergebnis-Box aktualisieren
});

//Falls man G-Wert des Input-Feldes ändert:
$("#idRGBG").bind('keyup mouseup', function () {
	changeColorPickerValue();		//wenn im Input-Feld der Wert geändert wird, dann soll der Wert des Color-Pickers ebenfalls geändert werden
	readRGB();		//Scroll-Ergebnis-Box aktualisieren
});

//Falls man B-Wert des Input-Feldes ändert:
$("#idRGBB").bind('keyup mouseup', function () {
	changeColorPickerValue();		//wenn im Input-Feld der Wert geändert wird, dann soll der Wert des Color-Pickers ebenfalls geändert werden
	readRGB();		//Scroll-Ergebnis-Box aktualisieren
});


/********************************************************************************
Toleranz festlegen und Suchfunktion starten, wenn man Toleranz einstellt:
********************************************************************************/
//Toleranz festlegen:
$( "#slider" ).slider({			//Slider initialisieren
  value: 1,									//Startwert ist 1
	change: function( event, ui ) {},			//Event-Listener aktivieren
});

document.getElementById('idChoosenTolerance').value = 1;   //Bei Programmstart die Toleranz auf 1 setzen

$("#idChoosenTolerance").bind('keyup mouseup', function () {		//Slider ändern, wenn man den Wert im Input-Feld ändert
	var choosenTolerance = document.getElementById('idChoosenTolerance').value;
	$( "#slider" ).slider( "option", "value", choosenTolerance );
	readRGB();		//Scroll-Ergebnis-Box aktualisieren
});

$( "#slider" ).on( "mousemove", function( event, ui ) {		//Den Wert im Input-Feld ändern, wenn man den Slider betätigt
	var slideTolerance = $( "#slider" ).slider( "option", "value" );
	document.getElementById('idChoosenTolerance').value = slideTolerance;
} );

$( "#slider" ).on( "slidestop", function( event, ui ) {		//Den Wert im Input-Feld ändern, wenn man den Slider betätigt
		readRGB();		//Nur wenn der User den Slider stoppt, soll die Datei durchsucht werden, bei mousemove-event wäre Browser überfordert
} );


/********************************************************************************
Wechsel zwischen XML- und STEP-Datei:
********************************************************************************/
// idDropdownSearch.onchange = function ()
// {
// 	var e = document.getElementById("idDropdownSearch");
// 	var searchEnding = e.options[e.selectedIndex].value;
// 	if (searchEnding == "XML")
// 		{searchFile = XMLFile;}
// 	else
// 		{searchFile = stepFile;}
// 	$('#search').keyup();			//keyup() simulieren, um das Such-Ergebnisfeld zu aktualisieren
// }


/********************************************************************************
Keyup-Funktion, falls vom User etwas eingegeben wird:
********************************************************************************/
$(document).ready(function()
{
	$('#search').keyup(function()
	{
		if (typeof searchFile == 'undefined') return;
		var searchFileCopy = searchFile;   	//Sicherheitskopie, um die Datei später wieder auf diesen Zustand zurücksetzen zu können
		var arFileSearch = ['.*','','.*'];     //.* muss hinten und vorne angefügt werden, damit nach der ganzen Zeile gesucht wird
		arFileSearch[1] = document.getElementById("search").value;
		if(arFileSearch[1]=="")
		{
			document.getElementById("idScrollSearch").innerHTML = "<i> -Suchbegriff eingeben- </i>";
			return;
		}

		//Suchausdrücke als fett umschreiben:
		var stEntrySearchField = arFileSearch[1];
		/* insert i for case-insensitive search */
		var rxEntrySearchField = new RegExp(stEntrySearchField,"g");
		var stEntrySearchFieldWithBold = '<b>' + arFileSearch[1] + '</b>';
		searchFile = searchFile.replace(rxEntrySearchField, stEntrySearchFieldWithBold);
		var stFileSearch = arFileSearch.join("");
		var rxFileSearch = new RegExp(stFileSearch,"g");    		//Aus String einen Regex machen
		var arFileSearchResult = searchFile.match(rxFileSearch);
		//Ersetze alle <-Zeichen und >-Zeichen, damit keine Verwechlung mit HTML-Tag:
		if(arFileSearchResult)  //Bedingung braucht man, weil es sonst zu Komplikationen kommt, falls Array leer ist
		{
			arFileSearch[1] = arFileSearch[1].replace(/</g,"&lt");  	//rxStEntrySearchFieldWithBoldWronglyRetyped würde sonst nichts finden, da bevor dieser Regex zur Anwendung kommt, alle <-Zeichen ausgetauscht werden würden
			arFileSearch[1] = arFileSearch[1].replace(/>/g,"&gt");		//rxStEntrySearchFieldWithBoldWronglyRetyped würde sonst nichts finden, da bevor dieser Regex zur Anwendung kommt, alle >-Zeichen ausgetauscht werden würden
			stEntrySearchFieldWithBold = '<b>' + arFileSearch[1] + '</b>';		//Überschreiben, damit korrekt gesucht werden kann

			var stEntrySearchFieldWithBoldWronglyRetyped = '&ltb&gt' + arFileSearch[1] + '&lt/b&gt';  //Dadurch, dass man alle <- und >-Zeichen ersetzt, würde Browser, nicht mehr fett schreiben, sondern <b> bzw. </b> ausschreiben
			// console.log("stEntrySearchFieldWithBoldWronglyRetyped String lautet: " + stEntrySearchFieldWithBoldWronglyRetyped);
			rxStEntrySearchFieldWithBoldWronglyRetyped = new RegExp(stEntrySearchFieldWithBoldWronglyRetyped,"g");

			for(i=0; i<arFileSearchResult.length; i++)
			{
				arFileSearchResult[i] = arFileSearchResult[i].replace(/</g,"&lt"); // Ersetzt alle <-Zeichen
				arFileSearchResult[i] = arFileSearchResult[i].replace(/>/g,"&gt"); // Ersetzt alle >-Zeichen
				arFileSearchResult[i] = arFileSearchResult[i].replace(rxStEntrySearchFieldWithBoldWronglyRetyped, stEntrySearchFieldWithBold); //Damit gefundene Ausdrücke wieder fett geschrieben werden
			}
		}

		if(arFileSearchResult)
			{writeBrowser(arFileSearchResult,"idScrollSearch","Gefundene Zeilen","noAdd");}
		else
			{document.getElementById("idScrollSearch").innerHTML = "<i> -Nichts gefunden- </i>"}

		//Wieder zurücksetzen, um die fett geschriebenen Inhalte wieder zurückzusetzen:
		searchFile = searchFileCopy;
	});
});


/********************************************************************************
Wandelt Hex- in R-, G-, oder B-Wert um:
********************************************************************************/
function hexToRgb(hex) {
    // Expand shorthand form (e.g. "03F") to full form (e.g. "0033FF")
    var shorthandRegex = /^#?([a-f\d])([a-f\d])([a-f\d])$/i;
    hex = hex.replace(shorthandRegex, function(m, r, g, b) {
        return r + r + g + g + b + b;
    });

    var result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
    return result ? {
        r: parseInt(result[1], 16),
        g: parseInt(result[2], 16),
        b: parseInt(result[3], 16)
    } : null;
}


/********************************************************************************
Wandelt RGB-Farbe in Hexadezimalschreibweise um:
********************************************************************************/
function rgbToHex(r,g,b)
	{return '#' + this.byte2Hex(r) + this.byte2Hex(g) + this.byte2Hex(b);}

function byte2Hex (n)
{
  var nybHexString = "0123456789ABCDEF";
  return String(nybHexString.substr((n >> 4) & 0x0F,1)) + nybHexString.substr(n & 0x0F,1);
}


/********************************************************************************
R-, G- oder B-Wert aus Input-Feld auslesen und Colorpicker-Wert dementsprechend anpassen:
********************************************************************************/
function changeColorPickerValue()
{
	var choosenR2 = document.getElementById('idRGBR').value;
	var choosenG2 = document.getElementById('idRGBG').value;
	var choosenB2 = document.getElementById('idRGBB').value;
	var convertedRGBtoHex = rgbToHex(choosenR2, choosenG2, choosenB2);
	document.getElementById("idColorPicker").value = convertedRGBtoHex;
}


/********************************************************************************
RBG-Werte auslesen:
********************************************************************************/
//Überprüfen, ob Farbwerte im Toleranzbereich liegen:
function readRGB ()
{
	resetInnerHTML("idScrollRGB"); 		//Erst mal das alte Ergebnis der Suche löschen
	var EnteredValueRGBR = document.getElementById('idRGBR').value;		//Eingegebener R-Wert
	var EnteredValueRGBG = document.getElementById('idRGBG').value;		//Eingegebener G-Wert
	var EnteredValueRGBB = document.getElementById('idRGBB').value;		//Eingegebener B-Wert
	var enteredTolerance = document.getElementById('idChoosenTolerance').value;

	/***********Farben, die mit Skala eingegeben sind checken:***********/
	const rxRGBGeneral = /#\d*=COLOUR_RGB*\(\s*'[^']*'\s*,\s*[^,]*,[^,]*,[^)]*\);/g;
	var arRGBResultGeneral = stepFile.match(rxRGBGeneral);   //zunächst alle COLOUR_RGB finden und zeilenweise in Array speichern
	if(arRGBResultGeneral)   //Nur wenn etwas gefunden wurde, soll weiter gemacht werden
	{
		for(i=0; i<arRGBResultGeneral.length; i++)
		{
			const rxRGBGroup = /COLOUR_RGB\s*\(\s*'[^']*'\s*,\s*([^,]*),([^,]*),([^)]*)\);/;		//Einen gefundenen String nach dem anderen durchgehen und nach R-, G-, B- Wert gruppieren
			var arRGBResult = arRGBResultGeneral[i].match(rxRGBGroup);
			var FoundValueRGBRDecimal =

			(arRGBResult[1]);				//Macht aus Exponentialdarstellung eine Dezimalzahl; bzw. falls Wert bereits in Dezimaldarstellung angegeben wurde, bleibt es eine Dezimaldarstellung
			var FoundValueRGBGDecimal = Number(arRGBResult[2]);				//Macht aus Exponentialdarstellung eine Dezimalzahl; bzw. falls Wert bereits in Dezimaldarstellung angegeben wurde, bleibt es eine Dezimaldarstellung
			var FoundValueRGBBDecimal = Number(arRGBResult[3]);				//Macht aus Exponentialdarstellung eine Dezimalzahl; bzw. falls Wert bereits in Dezimaldarstellung angegeben wurde, bleibt es eine Dezimaldarstellung
			var EnteredValueRGBRPercent = EnteredValueRGBR/255;				//Eingegebenen Wert in 0 bis 1 Skala umwandeln... Falls nichts eingegeben wurde, wird EnteredValueRGBRPercent zu 0
			var EnteredValueRGBGPercent = EnteredValueRGBG/255;				//Eingegebenen Wert in 0 bis 1 Skala umwandeln... Falls nichts eingegeben wurde, wird EnteredValueRGBGPercent zu 0
			var EnteredValueRGBBPercent = EnteredValueRGBB/255;				//Eingegebenen Wert in 0 bis 1 Skala umwandeln... Falls nichts eingegeben wurde, wird EnteredValueRGBBPercent zu 0

			var toggleNotWithinTolerance = 0;		//Nullen bei Bätitigen des RUN-Buttons
			toggleNotWithinTolerance = checkToleranceRange(EnteredValueRGBRPercent, FoundValueRGBRDecimal, 'idChoosenTolerance', enteredTolerance);
			if(toggleNotWithinTolerance == 0)		//Nur wenn noch nichts gefunden wurde
				{toggleNotWithinTolerance = checkToleranceRange(EnteredValueRGBGPercent, FoundValueRGBGDecimal, 'idChoosenTolerance', enteredTolerance);}
			if(toggleNotWithinTolerance == 0)		//Nur wenn noch nichts gefunden wurde
				{toggleNotWithinTolerance = checkToleranceRange(EnteredValueRGBBPercent, FoundValueRGBBDecimal, 'idChoosenTolerance', enteredTolerance);}
			if(toggleNotWithinTolerance == 0)   //Falls R-, G- oder B-Wert nicht im Toleranzbereich liegt
				{document.getElementById('idScrollRGB').innerHTML += arRGBResultGeneral[i] + "<br>";}
		}
	}


	/***********Farben, die mit Literalen eingegeben sind checken:***********/
	const rxRGBColorPreDefined = /#\d*\s*=\s*DRAUGHTING_PRE_DEFINED_COLOUR\s*\(\s*'\s*\w*\s*'\s*\)\s*;/g;
	var arRGBResultGeneralColorPreDefined = stepFile.match(rxRGBColorPreDefined);   //zunächst alle Zeilen in arRGBResultGeneralColorPreDefined speichern
	if(arRGBResultGeneralColorPreDefined)
	{
		for(i=0; i<arRGBResultGeneralColorPreDefined.length; i++)
		{
			const rxRGBGroupColorPreDefined = /#\d*\s*=\s*DRAUGHTING_PRE_DEFINED_COLOUR\s*\(\s*'\s*(\w*)\s*'\s*\)\s*;/;		//Einen gefundenen String nach dem anderen durchgehen und nach R-, G-, B- Wert gruppieren
			var arRGBGroupResultColorPreDefined = arRGBResultGeneralColorPreDefined[i].match(rxRGBGroupColorPreDefined);

			switch(arRGBGroupResultColorPreDefined[1])
			{
				case 'red':
					var togglePreDefined = readRGBColorPreDefined(1, 0, 0, EnteredValueRGBR, EnteredValueRGBG, EnteredValueRGBB, enteredTolerance);
					if(togglePreDefined == 0)
					 {document.getElementById('idScrollRGB').innerHTML += arRGBResultGeneralColorPreDefined[i] + "<br>";}
					break;
				case 'green':
					var togglePreDefined = readRGBColorPreDefined(0, 1, 0, EnteredValueRGBR, EnteredValueRGBG, EnteredValueRGBB, enteredTolerance);
					if(togglePreDefined == 0)
					 {document.getElementById('idScrollRGB').innerHTML += arRGBResultGeneralColorPreDefined[i] + "<br>";}
					break;
				case 'blue':
					var togglePreDefined = readRGBColorPreDefined(0, 0, 1, EnteredValueRGBR, EnteredValueRGBG, EnteredValueRGBB, enteredTolerance);
					if(togglePreDefined == 0)
					 {document.getElementById('idScrollRGB').innerHTML += arRGBResultGeneralColorPreDefined[i] + "<br>";}
					break;
				case 'yellow':
					var togglePreDefined = readRGBColorPreDefined(1, 1, 0, EnteredValueRGBR, EnteredValueRGBG, EnteredValueRGBB, enteredTolerance);
					if(togglePreDefined == 0)
					 {document.getElementById('idScrollRGB').innerHTML += arRGBResultGeneralColorPreDefined[i] + "<br>";}
					break;
				case 'magenta':
					var togglePreDefined = readRGBColorPreDefined(1, 0, 1, EnteredValueRGBR, EnteredValueRGBG, EnteredValueRGBB, enteredTolerance);
					if(togglePreDefined == 0)
					 {document.getElementById('idScrollRGB').innerHTML += arRGBResultGeneralColorPreDefined[i] + "<br>";}
					break;
				case 'cyan':
					var togglePreDefined = readRGBColorPreDefined(0, 1, 1, EnteredValueRGBR, EnteredValueRGBG, EnteredValueRGBB, enteredTolerance);
					if(togglePreDefined == 0)
					 {document.getElementById('idScrollRGB').innerHTML += arRGBResultGeneralColorPreDefined[i] + "<br>";}
					break;
				case 'black':
					var togglePreDefined = readRGBColorPreDefined(0, 0, 0, EnteredValueRGBR, EnteredValueRGBG, EnteredValueRGBB, enteredTolerance);
					if(togglePreDefined == 0)
					 {document.getElementById('idScrollRGB').innerHTML += arRGBResultGeneralColorPreDefined[i] + "<br>";}
					break;
				case 'white':
					var togglePreDefined = readRGBColorPreDefined(1, 1, 1, EnteredValueRGBR, EnteredValueRGBG, EnteredValueRGBB, enteredTolerance);
					if(togglePreDefined == 0)
					 {document.getElementById('idScrollRGB').innerHTML += arRGBResultGeneralColorPreDefined[i] + "<br>";}
					break;
			}
		}
	}

	//Falls nichts gefunden wurde, wird nichts gefunden- ausgeschrieben:
	if(document.getElementById("idScrollRGB").innerHTML == "")
		{document.getElementById("idScrollRGB").innerHTML = "<i> -nothing found- </i>";}
}


/********************************************************************************
Ausgeschriebene Farben (z.B. 'green') auslesen und ausschreiben:
********************************************************************************/
function readRGBColorPreDefined(FoundValueRGBR, FoundValueRGBG, FoundValueRGBB, EnteredValueRGBR, EnteredValueRGBG, EnteredValueRGBB, enteredTolerance)
{
	var EnteredValueRGBRPercent = EnteredValueRGBR/255;				//Eingegebenen Wert in 0 bis 1 Skala umwandeln... Falls nichts eingegeben wurde, wird EnteredValueRGBRPercent zu 0
	var EnteredValueRGBGPercent = EnteredValueRGBG/255;				//Eingegebenen Wert in 0 bis 1 Skala umwandeln... Falls nichts eingegeben wurde, wird EnteredValueRGBGPercent zu 0
	var EnteredValueRGBBPercent = EnteredValueRGBB/255;				//Eingegebenen Wert in 0 bis 1 Skala umwandeln... Falls nichts eingegeben wurde, wird EnteredValueRGBBPercent zu 0

	var toggleNotWithinTolerance = 0;		//Nullen
	toggleNotWithinTolerance = checkToleranceRange(EnteredValueRGBRPercent, FoundValueRGBR, 'idChoosenTolerance', enteredTolerance);
	if(toggleNotWithinTolerance == 0)		//Nur wenn R-Wert im Toleranzbereich liegt, soll weitergemacht werden
		{toggleNotWithinTolerance = checkToleranceRange(EnteredValueRGBGPercent, FoundValueRGBG, 'idChoosenTolerance', enteredTolerance);}
	if(toggleNotWithinTolerance == 0)		//Nur wenn G-Wert im Toleranzbereich liegt, soll weitergemacht werden
		{toggleNotWithinTolerance = checkToleranceRange(EnteredValueRGBBPercent, FoundValueRGBB, 'idChoosenTolerance', enteredTolerance);}
	return toggleNotWithinTolerance;		//0 bedeutet, dass der Wert im Toleranzbereich liegt. 1 bedeutet, dass der Wert nicht im Toleranzbereich liegt
}


/********************************************************************************
Testet, ob Wert im Toleranzbereich liegt oder nicht:
********************************************************************************/
function checkToleranceRange (EnteredValueRGBPercent, FoundValueRGBDecimal, idToleranceInput, enteredTolerance)
{
	var toggleTolerance = 0;
	var selecedTolerance = enteredTolerance;
	selecedTolerance /= 100;				//Durch Hundert teilens
	if (((EnteredValueRGBPercent-selecedTolerance) < FoundValueRGBDecimal) == true)
	{
		if((FoundValueRGBDecimal < (EnteredValueRGBPercent+selecedTolerance)) == true)
			{/*console.log("Der Wert liegt im Toleranzbereich");*/}
		else
			{toggleTolerance = 1;}    	//Falls Wert nicht im Toleranzbereich liegt
	}
	else
		{toggleTolerance = 1;}				//Falls Wert nicht im Toleranzbereich liegt
	return toggleTolerance;
}
